// ambient sound event handler

// https://quicksounds.com/#
// https://audiotoolset.com/editor

class idleambiance_decoration_EventHandler : EventHandler
{
	const CHAN_AMBIENCE = 20;

// ITEM v-------------------------------------------------
	struct item
	{
		name cname; //items name
		sound sname; //sound name
		int flags; // chanf flags
		double volume; // volume, 1 by defalut unless defined
	}
	item ItemSounds[50];
	int iCounter;
// ITEM ^-------------------------------------------------

	void addItemSounds(name cname, sound sname, int flags, double volume = 1.0)
	{
		ItemSounds[iCounter].cname = cname;
		ItemSounds[iCounter].sname = sname;
		ItemSounds[iCounter].flags = flags;
		ItemSounds[iCounter].volume = volume;
		iCounter++;
	}

	void LoadArrays()
	{
		iCounter = 0;
		
          // Array to define what items play with defined sound
           // items name, soundname, flags, volume
        // ---Problem with only playing first one
        //--vTECHv---------------------
        //addItemSounds("ZombieMan", "buzz", CHANF_LISTENERZ | CHANF_LOOPING); //monster test, works but stays after death
        addItemSounds("Column", "buzz", CHANF_LISTENERZ | CHANF_LOOPING, 1.5); //lamp
		addItemSounds("TechLamp", "buzz", CHANF_LISTENERZ | CHANF_LOOPING, 1.5);
		addItemSounds("TechLamp2", "buzz", CHANF_LISTENERZ | CHANF_LOOPING, 1.5);
		addItemSounds("TechPillar", "portal_beam_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.7); // machine
		addItemSounds("BurningBarrel", "fire_small_loop2", CHANF_LISTENERZ | CHANF_LOOPING, 0.2);
        //--^TECH^----------------------
        //--vHELL COLUMNSv-------------------------
        addItemSounds("EvilEye", "drone4lp", CHANF_LISTENERZ | CHANF_LOOPING);
        addItemSounds("HeartColumn", "heartbeat1", CHANF_LISTENERZ | CHANF_LOOPING);
		addItemSounds("SkullColumn", "drone2lp", CHANF_LISTENERZ | CHANF_LOOPING);
		addItemSounds("ShortRedColumn", "drone2lp", CHANF_LISTENERZ | CHANF_LOOPING);
        addItemSounds("ShortGreenColumn", "drone2lp", CHANF_LISTENERZ | CHANF_LOOPING);
        addItemSounds("TallRedColumn", "drone2lp", CHANF_LISTENERZ | CHANF_LOOPING);
		addItemSounds("TallGreenColumn", "drone2lp", CHANF_LISTENERZ | CHANF_LOOPING);
		//addItemSounds("Candlestick", "drone2lp", CHANF_LISTENERZ | CHANF_LOOPING);
		addItemSounds("Headcandles", "drone2lp", CHANF_LISTENERZ | CHANF_LOOPING); //skulls with candles
        //addItemSounds("candelabra", "drone4lp", CHANF_LISTENERZ | CHANF_LOOPING);
        //--^HELL COLUMNS^----------------------------------
        //--vHELL LIGHTSv----------------
        addItemSounds("RedTorch", "fire_small_loop2", CHANF_LISTENERZ | CHANF_LOOPING, 0.05);
        addItemSounds("BlueTorch", "fire_small_loop2", CHANF_LISTENERZ | CHANF_LOOPING, 0.05);
        addItemSounds("GreenTorch", "fire_small_loop2", CHANF_LISTENERZ | CHANF_LOOPING, 0.05);
        addItemSounds("ShortRedTorch", "fire_small_loop2", CHANF_LISTENERZ | CHANF_LOOPING, 0.05);
        addItemSounds("ShortBlueTorch", "fire_small_loop2", CHANF_LISTENERZ | CHANF_LOOPING, 0.05);
        addItemSounds("ShortGreenTorch", "fire_small_loop2", CHANF_LISTENERZ | CHANF_LOOPING, 0.05);
        addItemSounds("FloatingSkull", "drone2lp", CHANF_LISTENERZ | CHANF_LOOPING, 0.05);// floating stony lava skulls
        //--^HELL LIGHTS^----------------
        //--vGORE DECORATIONSv-----------
        addItemSounds("BloodyTwitch", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);// Twitching Hanging Body
        addItemSounds("NonsolidTwitch", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);// can be walked through
        addItemSounds("BrainStem", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);// Brains
        addItemSounds("DeadStick", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);// Dead Impaled Body
        addItemSounds("LiveStick", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);// Twitching Impaled Body
        addItemSounds("HangBNoBrain", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);// Hanging Body (Missing Brain)
        addItemSounds("HangTNoBrain", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);// Hanging Torso (Missing Brain)
        addItemSounds("HangNoGuts", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1); // Hanging Body (Missing Insides)
        addItemSounds("HangTLookingDown", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1); // Hanging Torso looking down
        addItemSounds("HangTLookingUp", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);// Hanging Torso looking up
        addItemSounds("HangTSkull", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);// Hanging Torso (Exposed Brain)
        addItemSounds("Meat2", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);// Hanging Body
        addItemSounds("NonsolidMeat2", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);// can be walked through
        addItemSounds("Meat3", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);// Hanging Body with missing leg
        addItemSounds("NonsolidMeat3", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);// can be walked through
        addItemSounds("Meat4", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);// Hanging Torso
        addItemSounds("NonsolidMeat4", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);// can be walked through
        //addItemSounds("Meat5", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);// Hanging Leg
        addItemSounds("HeadOnAStick", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);
        //addItemSounds("DeadMarine", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1); // Marine corpse
        //addItemSounds("GibbedMarine", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1); // Gibbed Marine Corpse
        //addItemSounds("GibbedMarineExtra", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1); // Gibbed Marine Corpse 2
        //--^GORE DECORATIONS^-----------
        //--vOTHERv-----------
        //addItemSounds("BigTree", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);//Large crooked tree. 
        //addItemSounds("Stalagtite", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);//Stalagmite (on the ground)
        //addItemSounds("TorchTree", "citadel_ambient_scream_loop1", CHANF_LISTENERZ | CHANF_LOOPING, 0.1);//Small burned tree. (stump?) 
        //--^OTHER^-----------
	}

    // spawns the audio
	override void WorldThingSpawned(WorldEvent e)
	{

		if (e.thing)
		{
            LoadArrays();
			for (int i = 0; i < iCounter; i++)
			{
				if (ItemSounds[i].cname == e.thing.GetSpecies())
				{
					//console.printf("Adding %s to %s", ItemSounds[i].sname, ItemSounds[i].cname); //debug
					/*Actor ptr = e.thing.Spawn("IA_Sound", e.thing.pos);
					if (ptr)
					{
						console.printf(ptr.getSpecies()); //debug
						ptr.A_StartSound(ItemSounds[i].sname, CHAN_AUTO, ItemSounds[i].flags, ItemSounds[i].volume);
					}*/
					
					// Just play the sound on the thing directly:
					e.thing.A_StartSound(ItemSounds[i].sname, CHAN_AMBIENCE, ItemSounds[i].flags, ItemSounds[i].volume);
					break;
				}
			}
		}
	} //<self contained

}

